/*
Si vuole scrivere un programma C per la gestione delle informazioni relative alle prenotazioni alberghiere on-line. I clienti per potere effettuare una prenotazione devono preventivamente registrarsi. Al momento della registrazione i clienti devono inserire i seguenti dati: codice fiscale, et, indirizzo e-mail e tipologia di cliente ( 0=privati, 1= aziendale).
Al momento della prenotazione i clienti forniscono i seguenti dati: codice fiscale, citt, data inizio (aaaa/mm/gg), numero giorni, numero stelle.
Le prenotazioni sono suddivise sulla base del numero di stelle dellalbergo e sono inserite in un vettore di 5 liste.
Le registrazioni dei clienti  realizzata attraverso una tabella allocata dinamicamente avente 2 righe, una per ogni tipologia di cliente.
Le prenotazioni sono inserite in modo ordinato rispetto alla data di inizio.
Scrivere un programma C che codifichi la struttura dati atta a mantenere in memoria le informazioni e che contenga un main che richiami attraverso un men di scelta le seguenti funzioni:
1) Inserimento di una nuova registrazione di un cliente
2) Visualizzazione del codice fiscale dei clienti di et maggiore di un valore di soglia da richiedere tramite tastiera (chiedere anche la tipologia).
3) Inserimento ordinato di una prenotazione.
4) Visualizzazione del numero di prenotazioni relative a una certa citt e a un certo numero di stelle ( Chiedere da tastiera la citt e il numero di stelle).
5) Salvataggio su file delle prenotazioni.
6) Lettura da file, visualizzazione e inserimento nel vettore di liste delle prenotazioni
Liberare la memoria allocata dinamicamente al termine dellesecuzione
Non usare variabili globali
*/



#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct{
        char codfisc[20];
        char citta[80];
        long codice;
        int eta;
        }registrazione;

typedef struct{
        char codfisc[20];
        char nomev[80];
        char data[12];
        int giorni;
        int stelle;
        }prenotazione;

struct atomo{
       prenotazione dato;
       struct atomo *next;
       };

void leggi_registrazione(registrazione *r);
void leggi_prenotazione(prenotazione *p);
void in_tab(registrazione **T,int *n,registrazione r);
void vis_tab(registrazione *T,int n, char *citta);
void in_lista(struct atomo **ptlista,prenotazione p);
int vis_lista(struct atomo *ptlista, char *data);
void salva_lista(struct atomo *VL[6]);
void carica_lista(struct atomo *VL[6]);

main()
{
      registrazione r,*T[3];
      prenotazione p;
      int N[3],i,scelta;
      struct atomo *VL[6],*aux;
      char citta[30],data[12];
      
     /*inizializzazione*/
        for(i=0;i<3;i++)
            {
                T[i]=NULL;
                N[i]=0;
            }
            
        for(i=0;i<6;i++)
           VL[i]=NULL;

       do{
           printf("\nScegli tra\n1)Inserimento registrazione\n2)Visualizzazione registrazione\n3)Inserimento prenotazione\n4)Visualizzazione prenotazione\n5)Salvataggio prenotazioni\n6)Caricamento prenotazione\n0)Fine\n");
           scanf("%d",&scelta);

       switch(scelta)
        {
              case 1:
                   leggi_registrazione(&r);
                   i=r.eta;
                   in_tab(&T[i],&N[i],r);
                   break;
              case 2:
                   printf("Fascia eta': ");
                   scanf("%d",&i);
                   printf("Citta': ");
                   scanf("%s",citta);
                   vis_tab(T[i],N[i],citta);
                   break;
              case 3:
                   leggi_prenotazione(&p);
                   i=p.stelle;
                   in_lista(&VL[i],p);
                   break;
              case 4:
                   printf("Stelle: ");
                   scanf("%d",&i);
                   printf("Data (aaaa/mm/gg) ");
                   scanf("%s",data);
                   vis_lista(VL[i],data);
                   break;
              case 5:
                   salva_lista(VL);
                   break;
              case 6:
                   carica_lista(VL);
                   break;
              default:;
        }
    }while(scelta!=0);

   /*liberiamo memoria*/
   for(i=0;i<3;i++)
      free(T[i]);
   
   for(i=0;i<6;i++)
         
       while(VL[i]!=NULL)
       {
        aux=VL[i];
        VL[i]=aux->next;
        free(aux);
       }
}
                   
void leggi_registrazione(registrazione *r)
{
     printf("Codice Fiscale: ");
     scanf("%s",r->codfisc);
     printf("Citta: ");
     scanf("%s",r->citta);
     printf("Codice Identificativo: ");
     scanf("%ld",&r->codice);
     printf("Eta: ");
     scanf("%d",&r->eta);
}
     
     
     
     
void in_tab(registrazione **T,int *n,registrazione r)
{
     registrazione *Ta;
     int p,i;
     
     Ta=(registrazione *)realloc(*T,sizeof(registrazione)*(*n+1));
     if(Ta==NULL)
        return;
     *T=Ta;
     
     for(p=0;p<*n;p++)
       if(strcmp(Ta[p].codfisc,r.codfisc)>0)
        break;
     for(i=*n;i>p;i--)
         Ta[i]=Ta[i-1];
         
     Ta[p]=r;
     (*n)++;
}
     
void vis_tab(registrazione *T,int n,char *citta)
{
     int i;
     
     for(i=0;i<n;i++)
        if(strcmp(citta,T[i].citta)==0)
           printf("Codice Identificativo: %ld\n",T[i].codice);
             
                     
}
                                                     
void leggi_prenotazione(prenotazione *p)
{
     printf("Codice Fiscale: ");
     scanf("%s",p->codfisc);
     printf("Nome Villaggio: ");
     scanf("%s",p->nomev);
     printf("Data: ");
     scanf("%s",p->data);
     printf("Giorni: ");
     scanf("%d",&p->giorni);
     printf("Stelle: ");
     scanf("%d",&p->stelle);
}
                                                     
void in_lista(struct atomo **ptlista,prenotazione p)
{
     struct atomo *aux;
     aux=(struct atomo*)malloc(sizeof(struct atomo));
     if(aux==NULL)
     return;
     aux->dato=p;
     aux->next=*ptlista;
     *ptlista=aux;
}
     
int vis_lista(struct atomo *ptlista, char *data)
{
     struct atomo *aux;
     
     int conta;
     
     aux=ptlista;
     conta=0;
     
     while(aux!=NULL)
     {
         if(strcmp(data,aux->dato.data)==0)
             conta=conta+1;
         
         aux=aux->next;
     }
     
     printf("Il numero di prenotazioni e': %d",conta);
}
   
                                                       
void salva_lista(struct atomo *VL[6])
{
     FILE *pf;
     int i;
     struct atomo *aux;
     prenotazione p;
     pf=fopen("prenotazione.p","w");
     if(pf)
     {
       for(i=0;i<6;i++)
        {
           aux=VL[i];
           while(aux!=NULL)
           {
             p=aux->dato;
             fwrite(&p,sizeof(prenotazione),1,pf);
             aux=aux->next;
           }
        }
       fclose(pf);
     }
}

void carica_lista(struct atomo *VL[6])
{
     struct atomo *aux;
     prenotazione p;
     int i;
     FILE *pf;
     pf=fopen("prenotazione.p","r");
     if(pf)
     {
           while(fread(&p,sizeof(prenotazione),1,pf)!=0)
           {
             i=p.stelle;
             in_lista(&VL[i],p);
           }
          
          fclose(pf);
     }
}
                                                   
                                                   
     


                   
                   
                   
                   


      
      
      
