/*
Si vuole scrivere un programma C per la gestione delle informazioni relative alle prenotazioni on-line di villaggi turistici. 
I clienti per potere effettuare una prenotazione devono preventivamente registrarsi.
 Al momento della registrazione i clienti devono inserire i seguenti dati: codice fiscale, citta, codice identificativo, e fascia di et ( 0= <18 anni, 1= 18<= et < 65, 2= altri).
Al momento della prenotazione i clienti forniscono i seguenti dati: codice fiscale, nome villaggio, data inizio (aaaa/mm/gg), numero giorni, numero stelle.
Le prenotazioni sono suddivise sulla base del numero di stelle del villaggio e sono inserire in un vettore di 6 liste.
Le registrazioni dei clienti  realizzata attraverso una tabella allocata dinamicamente avente 3 righe, una per ogni fascia di et.
Le registrazioni sono inserite in modo ordinato rispetto al codice fiscale.
Scrivere un programma C che codifichi la struttura dati atta a mantenere in memoria le informazioni 
e che contenga un main che richiami attraverso un men di scelta le seguenti funzioni:
1. Inserimento ordinato rispetto al codice fiscale di una nuova registrazione di un cliente
2. Visualizzazione del codice identificativo dei clienti di una certa citt ( chiedere tramite tastiera la citt e la fascia det)
3. Inserimento di una prenotazione.
4. Visualizzazione del numero di prenotazioni relative a una certa data e a un certo numero di stelle ( Chiedere da tastiera la data e il numero di stelle).
5. Salvataggio su file delle prenotazioni
6. Lettura da file e inserimento nel vettore di liste delle prenotazioni
Liberare la memoria allocata dinamicamente al termine dellesecuzione
Non usare variabili globali


*/
  #include<stdio.h>
  #include<stdlib.h>
  #include<string.h>
  
  
  struct clienti {
         char codfisc [17],citta [20];
         long codice;
         int fascia;
         };
         
  struct prenotazione  {
         char codfisc [17],nome [20],data [8];
         int stelle,giorni;
         };
         
  struct atomo {
         struct prenotazione dato;
         struct atomo *next;
         };

void leggi_cli(struct clienti *c);
void ins_ord_cli(struct clienti *T[3], int N[3],struct clienti c);   
void visualizza(struct clienti *T[3],int *N);
void leggi_pre(struct prenotazione *p);
void in_lista(struct atomo **L,struct prenotazione p);
void da_lista(struct atomo **tl);
void visualizza_pre(struct atomo *L[6]);
void salva(struct atomo *L[6]);
void leggi_file(struct atomo *L[6]);


main() {
       struct atomo *L[6];
       struct clienti *T[3],c;
       int N[3],i,scelta;
       struct prenotazione p;
       
       for(i=0;i<3;i++)
       { T[i]=NULL;
         N[i]=0;
         }
       for(i=0;i<6;i++)
       L[i]=NULL;
       
       
       do {
           printf("\n  -------Scelta------- \n\n");
           printf("1) Inserisci registrazione cliente \n");
           printf("2) Visualizza clienti \n");
           printf("3) Inserisci prenotazione \n");
           printf("4) Visualizza numero di prenotazioni \n");
           printf("5) Salva su file \n");
           printf("6) Leggi da file \n");
           printf("0) Fine \n");
           scanf("%d",&scelta);
           switch(scelta)
           {
           
           case 1: /*Inserimento cliente*/
                   leggi_cli(&c);
                   ins_ord_cli(T,N,c);
                   break;
                   
           case 2: /*visualizzazione clienti*/
                   visualizza(T,N);
                   break;
                   
           case 3: /*inserimento prenotazione*/ 
                   leggi_pre(&p);
                   i=p.stelle;
                   in_lista(&L[i],p);
                   break;
                   
           case 4:/*Visualizzazione numero prenotazioni*/  
                   visualizza_pre(L);
                   break;
           case 5: /*salvataggio*/
                   salva(L);
                    break;
                    
           case 6:/*letture da file*/ 
                   leggi_file (L);
                   break;
           default:;
                   }
                   }
                   while(scelta!=0);
                   for(i=0;i<3;i++)
                   free(T[i]);
                   for(i=0;i<6;i++)
                    while(L[i]!=NULL)
                    da_lista(&L[i]);
}


     
void leggi_cli(struct clienti *c)
{
     printf("Codice fiscale \n");
     scanf("%s",c->codfisc);
     printf("Citta' \n");
     scanf("%s",c->citta);
     printf("Codice identificativo \n");
     scanf("%ld",&c->codice);
     printf("Fascia eta'(0=<18 anni), 1=18<=eta'<65, 2=altri) \n");
     scanf("%d",&c->fascia);
     }
     
void ins_ord_cli(struct clienti *T[3], int N[3],struct clienti c)
{
     int i,j,f;
     struct clienti *aux;
     
     f=c.fascia;
     aux=realloc(T[f],sizeof(struct clienti )*(N[f]+1));
     if(aux==NULL)
     return;
     T[f]=aux;
     
     for(i=0;i<N[f];i++)
        if(strcmp(c.codfisc,T[f][i].codfisc)<0)
            break;
     
     
     for(j=N[f];j>i;j--)
     T[f][j]=T[f][j-1];
     
     T[f][i]=c;
     N[f]++;
     }

void visualizza(struct clienti *T[3],int *N)
{
     int f,j;
     char citta [20];
     
     printf("Citta' \n");
     scanf("%s",citta);
     printf("Fascia eta (0=<18 anni), 1=18<=eta'<65, 2=altri) \n");
     scanf("%d",&f);
     for(j=0;j<N[f];j++)
         if(strcmp(T[f][j].citta,citta)==0)
                 printf("Codice indentificativo %d\n",T[f][j].codice);
                             
                          
     }

void leggi_pre(struct prenotazione *p)
{
     printf("Codice fiscale \n");
     scanf("%s",p->codfisc);
     printf("Nome \n");
     scanf("%s",p->nome);
     printf("Data inizio (aaaa/mm/gg)\n");
     scanf("%s",p->data);
     printf("Stelle (0..4)\n");
     scanf("%d",&p->stelle);
     printf("Giorni \n");
     scanf("%d",&p->giorni);
     }
             
void in_lista(struct atomo **L,struct prenotazione p)
{
     struct atomo *aux;
     aux=(struct atomo *)malloc(sizeof(struct atomo));
     if(aux==NULL)
     return;
     
     aux->dato=p;
     aux->next=*L;
     *L=aux;
     }
     
void da_lista(struct atomo **tl)
{
     struct atomo *aux;
     aux=*tl;
     *tl=aux->next;
     free(aux);
     }
     
void visualizza_pre(struct atomo *L[6])
{
     struct atomo *aux;
     int numero,i;
     char data [8];
     
      
     printf("Numero di stelle \n");
     scanf("%d",&i);
     printf("Data \n");
     scanf("%s",data);
     numero=0;
     aux=L[i];
     while(aux!=NULL)
       {    if(strcmp(aux->dato.data,data)==0)
                 numero++;
            aux=aux->next;
       } 
     printf("Il numero di prenotazioni sono %d\n",numero);
}
     
void salva(struct atomo *L[6])
{
     FILE *pf;
     int i;
     struct atomo *aux;
     struct prenotazione p;
     
     pf=fopen("prenotazione.txt","w");
     if(pf!=NULL)
        {
           for(i=0;i<6;i++)
               { 
                   aux=L[i];
                   while(aux!=NULL)
                    {
                       p=aux->dato;
                       fwrite(&p,sizeof(struct prenotazione),1,pf);
                       
                       aux=aux->next;
                    }
               }
           fclose(pf);
        }
}
     
void leggi_file(struct atomo *L[6])
{
     FILE *pf;
     struct prenotazione p;
     int i;
     pf=fopen("prenotazione.txt","r");
     if(pf!=NULL)
     {
          while(fread(&p,sizeof(struct prenotazione),1,pf)!=0)
             {  
               i=p.stelle;
               in_lista(&L[i],p);
             }
          fclose(pf);
     }
}                 
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
  
     
     
     
     
