/*  
Si vuole scrivere un programma C per la gestione delle informazioni relative a un servizio di bike sharing.
Le persone che intendono utilizzare tale servizio devono essere registrate. 
Per la registrazione devono essere inserite i seguenti dati: codice fiscale, citt, sesso e tipo moto ( 0= < 150 cc, 1= 250<= cc < =500, 3= cc> 500 ).
Le registrazioni delle persone  realizzata attraverso una vettore di 3 lista, una per ogni tipo di moto.
Al momento della prenotazione di una moto devono essere forniti i seguenti dati: codice fiscale, data (aaaa/mm/gg), numero di ore, fascia di et.
Le prenotazioni sono suddivise sulla base alla fascia det e sono inserire in una tabella allocata dinamicamente con 4 righe, una per ogni fascia.
Scrivere un programma C che codifichi la struttura dati atta a mantenere in memoria le informazioni 
e che contenga un main che richiami attraverso un men di scelta le seguenti funzioni:
1) Inserimento ordinato rispetto al codice fiscale di una nuova registrazione
2) Ricerca di una persona ( chiedere tramite tastiera solo il codice fiscale e visualizzare citt, sesso e tipo di moto).
3) Inserimento di una prenotazione.
4) Eliminazione dellultima prenotazione dopo averla visualizzata ( Chiedere da tastiera  la fascia d'eta).
5) Salvataggio su file delle prenotazioni
6) Lettura da file e inserimento nella tabella delle prenotazioni con data precedenti una valore di soglia letto da tastiera.
Liberare la memoria allocata dinamicamente al termine dellesecuzione
Non usare variabili globali 
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct registrazione{
       char fiscale[17];
       char citta[20];
       int sesso;
       int tipo;
       };

struct atomo{
       struct registrazione dato;
       struct atomo *next;
       };
       
struct prenotazione{
       char fiscale[17];
       char data[12];
       int ore;
       int fascia;
       };
       

void leggi_registrazione(struct registrazione *r);
void in_lista(struct atomo **l,struct registrazione x);
void ins_ord(struct atomo **l,struct registrazione x);
void ricerca(struct atomo *VL[3]);
void leggi_prenotazione(struct prenotazione *p);
void ins_prenotazione(struct prenotazione *T[4],int N[4],struct prenotazione x);
void elimina(struct prenotazione *T[4],int N[4]);
void salva(struct prenotazione *T[4],int N[4]);
void carica(struct prenotazione *T[4],int N[4],char data[12]);
void svuota_lista(struct atomo **l);

main() {
       int i,opz;
       struct atomo *VL[3];
       struct prenotazione *T[4],pr;
       int N[4];
       struct registrazione re;
       char data[12];
       
       for(i=0;i<4;i++)
       {
         T[i]=NULL;
         N[i]=0;
         }
         
       for(i=0;i<3;i++)
       VL[i]=NULL;
       
       do{
                  printf("\n-----------SERVIZIO DI BIKE SHARING-----------\n\n");
                  printf(">>>>>>>>>>>>>>>>>>>>>MENU'<<<<<<<<<<<<<<<<<<<<<<\n");
                  printf("Seleziona una delle seguenti operazioni:\n");
                  printf("1)Inserisci una nuova registrazione\n2)Ricerca di una persona\n");
                  printf("3)Inserisci una nuova prenotazione\n4)Elimina ultima prenotazione\n");
                  printf("5)Salva prenotazioni su file\n6)Leggi prenotazioni da file\n");
                  printf("0) Fine esecuzione\n");
                  scanf("%d",&opz);
                  
                  switch(opz){
                              
                              case 1: leggi_registrazione(&re);
                                      i=re.tipo;
                                      ins_ord(&VL[i],re);
                                      break;
                                      
                              case 2: ricerca(VL);
                                      break;
                                      
                              case 3: leggi_prenotazione(&pr);
                                      ins_prenotazione(T,N,pr);
                                      break;
                                      
                              case 4: elimina(T,N);
                                      break;
                                      
                              case 5: salva(T,N);
                                      break;
                                      
                              case 6: printf("Inserire data : ");
                                      scanf("%s",data);
                                      carica(T,N,data);
                                      break;
                                      
                              default:;
                              }
                              
                  }while(opz!=0);
                  
                  for(i=0;i<4;i++)
                  free(T[i]);
                  
                  for(i=0;i<3;i++)
                  svuota_lista(&VL[i]);
                  
}

void leggi_registrazione(struct registrazione *r)
{
     printf("\nCodice fiscale: ");
     scanf("%s",r->fiscale);
     printf("Citta': ");
     scanf("%s",r->citta);
     printf("Sesso: (0=Maschio 1=Femmina) ");
     scanf("%d",&r->sesso);
     printf("Tipo moto:\n0)cc<150\n1)250<=cc<=500\n2)cc>350\n");
     scanf("%d",&r->tipo);
}

void in_lista(struct atomo **l,struct registrazione x)
{
     struct atomo *aux;
     
     aux=(struct atomo *)malloc(sizeof(struct atomo));
     if(aux==NULL)
     return;
     
     aux->dato=x;
     aux->next=*l;
     *l=aux;
}

void ins_ord(struct atomo **l,struct registrazione r)
{
     if(*l==NULL || strcmp(r.fiscale,(*l)->dato.fiscale)<0)
           in_lista(l,r);
     else ins_ord(&(*l)->next,r);
}
     
void ricerca(struct atomo *VL[3])
{
     int i;
     struct atomo *aux;
     char fiscale[17];

     
     printf("Inserisci codice fiscale della persona che vuoi cercare: ");
     scanf("%s",fiscale);
     
     for(i=0;i<3;i++)
     { 
      aux=VL[i];
       while(aux!=NULL)
         {
            if(strcmp(fiscale,aux->dato.fiscale)==0)
             
                {
                  printf("Citta': %s\n",aux->dato.citta);
                  printf("\nSesso (0=Maschio 1=Femmina) : %d\n",aux->dato.sesso);
                  printf("\nTipo di moto (0=cc<150 1=250<=cc<=500 2=cc>350): %d \n",aux->dato.tipo);
                  return;
                }
                                                        
                                                        
            aux=aux->next;
         }
                                                        
     }
     /* se arriviamo in questo punto la persona non e' stata trovata*/
     printf("La persona cercata non e' presente\n");
     
}
          
void leggi_prenotazione(struct prenotazione *p)
{
     printf("Codice fiscale: ");
     scanf("%s",p->fiscale);
     printf("Data: (aaaa/mm/gg) ");
     scanf("%s",p->data);
     printf("Numero di ore: ");
     scanf("%d",&p->ore);
     printf("Fascia d'eta': (0..3) ");
     scanf("%d",&p->fascia);
}

void ins_prenotazione(struct prenotazione *T[4],int N[4],struct prenotazione x)
{
     struct prenotazione *Ta;
     int i;
     
     i=x.fascia;
     
     Ta=(struct prenotazione *) realloc(T[i],(N[i]+1)*sizeof(struct prenotazione));
     if(Ta==NULL)
     return;
     
     T[i]=Ta;
     Ta[N[i]]=x;
     N[i]++;
}

void elimina(struct prenotazione *T[4],int N[4])
{
     int i,j;
     
     
     printf("\nFascia d'eta': (0..3 ");
     scanf("%d",&i);
     
     
     if(T[i]==NULL)
          { printf("Nessun elemento da eliminare\n");
            return;
          } 
     else 
     
     {/* visualizziamo l'ultimo elemento della riga di indice i che si trova in 
         posizione N[i-1]  */
      printf("\nCodice fiscale: %s\n",T[i][N[i-1]].fiscale);
      printf("Data: %s\n",T[i][N[i-1]].data);
      printf("Numero di ore: %d\n",T[i][N[i-1]].ore);
      
      /* eliminiamo l'ultimo elemento */
      N[i]--;
      T[i]=(struct prenotazione *) realloc(T[i],N[i]*sizeof(struct prenotazione));
     }
}
     
void salva(struct prenotazione *T[4],int N[4])
{
     FILE *pf;
     char nomefile[20];
     int i;
     
     printf("Nome file: ");
     scanf("%s",nomefile);
     
     pf=fopen(nomefile,"w");
     if(pf) {
              for(i=0;i<4;i++)
                 fwrite(T[i],sizeof(struct prenotazione),N[i],pf);
              fclose(pf);
            }
}

void carica(struct prenotazione *T[4],int N[4],char data[12])
{
     FILE *pf;
     struct prenotazione x;
     char nomefile[20];
     
    printf("Nome file: ");
    scanf("%s",nomefile);

    pf=fopen(nomefile,"r");
    if(pf) {
             while(fread(&x,sizeof(struct prenotazione),1,pf)!=0)
                  if(strcmp(data,x.data)>0)
                    ins_prenotazione(T,N,x);
                                           
             fclose(pf);
                                            
           }
}

               
void svuota_lista(struct atomo **l)
{
     struct atomo *aux;
     
     while(*l!=NULL)
     {
       aux=*l;
       *l=aux->next;
       free(aux);
     }
}
