/*
Scrivere un programma per la gestione dei servizi presso un CAAF.
Per accedere ai servizi  necessario inserirsi in coda. Presso il CAAF sono presenti due code, una per i soci e laltra per i non soci. Al momento dellinserimento di una persona in una delle due code sono richieste: codice fiscale, tipo di servizio, tipo di persona (0=non socio, 1=socio).
La registrazione dei soci avviene inserendo le seguenti informazioni in una tabella allocata dinamicamente: codice fiscale, data di nascita, numero iscrizione, tipo di socio (0=lavoratore dipendente, 1=lavoratore autonomo, 2= pensionato).
La tabella contiene 3 righe, una per ogni tipo di socio. Ogni riga  ordinata rispetto al codice fiscale.
Scrivere un programma C che codifichi la struttura dati atta a mantenere in memoria le informazioni e che contenga un main che richiami attraverso un men di scelta le seguenti funzioni:
1) Inserimento ordinato di un nuovo socio;
2) Visualizzazione del numero di soci con data di nascita inferiore a un valore di soglia da leggere tramite tastiera;
3) Inserimento in coda;
4) Eliminazione da una delle due code (chiedere il tipo di persona da servire);
5) Salvataggio su file degli elementi delle code. Visualizzare sullo schermo i valori salvati
Allavvio del programma i valori precedentemente salvati su file devono essere letti e copiati nel vettore di code mediante una funzione di inizializzazione.
Liberare la memoria allocata dinamicamente.


*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct {
        char codfisc[20];
        int tipo_servizio,tipop;
        }servizio;

struct atomocoda {
       servizio dato;
       struct atomocoda *suc;
       };

struct coda {
       struct atomocoda *primo,*ultimo;
       };

typedef struct {
        char codfisc[20],data[15];
        int numero,tipo;
        }socio;

void ins_ordinato(socio  *V[3],int N[3],socio x);
void visualizza_tab(socio *V[3],int N[3]);
void leggi_socio(socio *s);
void in_coda(struct coda Q[2],servizio x);
void out_coda(struct coda *Q);
void leggi_servizio(servizio *s);
void salva(struct coda Q[2]);
void carica(struct coda Q[2]);


main() {
       socio *V[3],s;
       int i,scelta,N[3];
       struct atomocoda *a;
       struct coda Q[2];
       servizio el;
       
       for(i=0;i<3;i++)
       {V[i]=NULL;
        N[i]=0;
       }
       
       for(i=0;i<2;i++)
       {Q[i].primo=NULL;
        Q[i].ultimo=NULL;
       }
        
        carica(Q);
       
       printf("\nProgramma per la gestione dei servizi presso un CAAF\n");
       do{printf("<<<<<<<<MENU>>>>>>>>\n");
          printf("Scegli tra:\n");
          printf("1)Inserimento di un socio\n");
          printf("2)Visualizzazione numero di soci\n");
          printf("3)Inserimento in coda\n");
          printf("4)Eliminazione da una coda\n");
          printf("5)Salvataggio degli elementi delle code e visualizzazione\n");
          printf("0)Fine\n");
          scanf("%d",&scelta);
          
          switch(scelta) {
          case 1 : leggi_socio(&s);
                   ins_ordinato(V,N,s);
                   break;
          case 2 : visualizza_tab(V,N);
                   break;
          case 3 : leggi_servizio(&el);
                   in_coda(Q,el);
                   break;
          case 4 : printf("Coda da servire:(0=non socio,1=socio):");
                   scanf("%d",&i);
                   if(Q[i].primo!=NULL)
                   out_coda(&Q[i]);
                   else printf("Coda vuota\n");
                   break;
          case 5 : salva(Q);
                   break;
          default:;}
       }while(scelta!=0);
          
          for(i=0;i<3;i++)
            free(V[i]);
          
          for(i=0;i<2;i++)
             while(Q[i].primo!=NULL)
             {a=Q[i].primo;
              Q[i].primo=a->suc;
              free(a);
             }
}

void leggi_socio(socio *s)
{
     printf("Tipo di socio(0=lavoratore dip,1=lavoratore autonomo,2=pensionato):");
     scanf("%d",&s->tipo);
     printf("Data di nascita(aaaa/mm/aa):");
     scanf("%s",s->data);
     printf("Numero iscrizione:");
     scanf("%d",&s->numero);
     printf("Codice fiscale:");
     scanf("%s",s->codfisc);
}

void ins_ordinato(socio  *V[3],int N[3],socio x)
{
     int i,j,k;
     socio *Va;
     
     j=x.tipo;
     Va=(socio *)realloc(V[j],(N[j]+1)*sizeof(socio));
     if(Va==NULL)
     return;
     
     /*eseguo l'inserimento ordinato mettendo in ordine alfabetico il codice fiscale*/
     V[j]=Va;
     for(i=0;i<N[j];i++)
       if(strcmp(V[j][i].codfisc,x.codfisc)>0)
         break;
       
     for(k=N[j];k>i;k--)
        V[j][k]=V[j][k-1];
     
     V[j][i]=x;
     N[j]++;
}

void visualizza_tab(socio *V[3],int N[3])
{
     char data[15];
     int i,j;
     int numero=0;
     
     printf("Inserisci data di nascita(aaaa/mm/gg):");
     scanf("%s",data);
     
     /*sara' visualizzato il numero di soci con data di nascita inferiore a quella inserita*/
     for(i=0;i<3;i++)
         for(j=0;j<N[i];j++)
            if(strcmp(V[i][j].data,data)<0)
               numero++;
            
     printf("Il numero di soci richiesti e' %d\n",numero);
}

void leggi_servizio(servizio *s)
{
     printf("Codice fiscale:");
     scanf("%s",s->codfisc);
     printf("Tipo di servizio:");
     scanf("%d",&s->tipo_servizio);
     printf("Tipo di persona(0=non socio,1=socio):");
     scanf("%d",&s->tipop);
}

void in_coda(struct coda Q[2],servizio x)
{
     struct atomocoda *a;
     
     a=(struct atomocoda *)malloc(sizeof(struct atomocoda));
     if(a==NULL)
     return;
     
     a->dato=x;
     a->suc=NULL;
     if(Q[x.tipop].primo==NULL)
        Q[x.tipop].primo=a;
     else Q[x.tipop].ultimo->suc=a;

     Q[x.tipop].ultimo=a;
}

void out_coda(struct coda *Q)
{
     struct atomocoda *l;
     
     l=Q->primo;
     Q->primo=l->suc;
     free(l);
     
     if(Q->primo==NULL)
       Q->ultimo=NULL;
}



void salva(struct coda Q[2])
{
     struct atomocoda *a;
     int i;
     FILE *pf;
     servizio s;
     
     pf=fopen("informatica.txt","w");
     if(pf){
            for(i=0;i<2;i++)
            { a=Q[i].primo;
              while(a!=NULL)
              { s=a->dato;
                fwrite(&s,sizeof(servizio),1,pf);
                
                printf("Codice fiscale:%s\n",s.codfisc);
                printf("Tipi di persona:%d,Tipo di servizio:%d\n\n",s.tipop,s.tipo_servizio);
                
                a=a->suc;
              }
            }
          }
}  

void carica(struct coda Q[2])
{
     struct atomocoda *l;
     FILE *pf;
     int i;
     servizio s;
     
     pf=fopen("informatica.txt","r");
     if(pf){
            while(fread(&s,sizeof(servizio),1,pf)!=0)
               in_coda(Q,s);
            fclose(pf);
           }
}

