/* 
Scrivere un programma per la gestione di un degli ordini dei prodotti in un magazzino.
Presso il magazzino vengono conservati in una tabella allocata dinamicamente i prodotti presenti nel magazzino. Ogni prodotto  caratterizzato da: codice prodotto, quantit presente, prezzo e tipo di prodotto. Si supponga che la tabella contenga 10 righe, una per ogni tipo di prodotto.
Gli ordine relativi ai prodotti sono caratterizzati da: numero ordine, codice prodotto, quantit richiesta, tipo di cliente.
Gli ordini sono presenti in un vettore di 5 liste, una per ogni tipo di cliente.
Scrivere un programma C che codifichi la struttura dati atta a mantenere in memoria le informazioni e che contenga un main che richiami attraverso un men di scelta le seguenti funzioni:
1. Inserimento di un nuovo prodotto;
2. Eliminazione del primo prodotto di una riga. Al momento delleliminazione visualizzare il codice prodotto e il prezzo;
3. Inserimento nel vettore di liste di un nuovo ordine;
4. Cancellazione di un ordine. Visualizzare il codice prodotto e la quantit dellelemento da cancellare (chiedere il numero dellordine e il tipo di cliente);
5. Salvataggio su file degli elementi della tabella.
Allavvio del programma i valori precedentemente salvati su file devono essere letti e copiati nella tabella mediante una funzione di inizializzazione.
Liberare la memoria allocata dinamicamente.
Non usare variabili globali
 */

#include <stdio.h>
#include <stdlib.h>

struct prodotto {
       int codice, quantita, tipo;
       float prezzo;
       };

struct ordine {
       int numero, codice, quantita, tipo;
       };

struct atomo {
       struct ordine dato;
       struct atomo *next;
       };

void leggi_prodotto(struct prodotto *p);
void leggi_ordine(struct ordine *o);
void in_tabella(struct prodotto *V[10], int N[10], struct prodotto x);
void elimina_prodotto(struct prodotto *V[10], int N[10]);
void in_lista(struct atomo **L, struct ordine x);
void elimina_ordine(struct atomo *L[5]);
void salva_tabella(struct prodotto *V[10], int N[10]);
void inizializza(struct prodotto *V[10], int N[10]);



main() {
       struct atomo *L[5], *aux;
       struct prodotto *V[10], p;
       struct ordine k;
       int i,scelta,N[10];
       
       for(i=0;i<5;i++)
          L[i]=NULL;
          
       for(i=0;i<10;i++)
          {V[i]=NULL;
           N[i]=0;
           }
       inizializza(V,N);
       
       do {
            printf("\t Gestione degli ordini dei prodotti di un magazzino\n\n");
            printf("1. Inserimento di un nuovo prodotto\n");
            printf("2. Eliminazione del primo prodotto di un certo tipo\n");
            printf("3. Inserimento in lista di un nuovo ordine\n");
            printf("4. Cancellazione di un ordine\n");
            printf("5. Salvataggio dei prodotti\n");
            printf("0. Fine\n");
            scanf("%d", &scelta);
            
            switch(scelta) {
                            case 1: leggi_prodotto(&p);
                                    in_tabella(V,N,p);
                                    break;
                            case 2: elimina_prodotto(V,N);
                                    break;
                            case 3: leggi_ordine(&k);
                                    in_lista(&L[k.tipo],k);
                                    break;
                            case 4: elimina_ordine(L);
                                    break;
                            case 5: salva_tabella(V,N);
                                    break;
                            default:;
                            }
            }while(scelta!=0);
            
            for(i=0;i<10;i++)
               free(V[i]);
            
            for(i=0;i<5;i++)
               while(L[i]!=NULL)
                    {aux=L[i];
                     L[i]=aux->next;
                     free(aux);
                    }
}




void leggi_prodotto(struct prodotto *p)
{
  printf("Codice prodotto: ");
  scanf("%d", &p->codice);
  printf("Quantita' presente: ");
  scanf("%d", &p->quantita);
  printf("Prezzo del prodotto: ");
  scanf("%f", &p->prezzo);
  printf("Tipo di prodotto(0..9): ");
  scanf("%d", &p->tipo);
}


void leggi_ordine(struct ordine *o)
{
 printf("Numero dell'ordine: ");
 scanf("%d", &o->numero);
 printf("Codice del prodotto: ");
 scanf("%d", &o->codice);
 printf("Quantita' richiesta: ");
 scanf("%d", &o->quantita);
 printf("Tipo di cliente(0..4): ");
 scanf("%d", &o->tipo);
}


void in_tabella(struct prodotto *V[10], int N[10], struct prodotto x)
{
 struct prodotto *Va;
 int i;
 i=x.tipo;
 Va=(struct prodotto *) realloc(V[i], sizeof(struct prodotto)*(N[i]+1));
 if(Va==NULL) return;
 
 V[i]=Va;
 V[i][N[i]]=x;
 N[i]++;
}


void elimina_prodotto(struct prodotto *V[10], int N[10])
{int i,j;

 printf("Che tipo di prodotto vuoi elimanre?(0..9): ");
 scanf("%d", &i);
 if(V[i]==NULL)
    {
     printf("\nNon esistono prodotti di questo tipo\n\n");
     return;
    }
    
 
 printf("Il codice del prodotto  e':%d\n", V[i][0].codice);
 printf("Il prezzo del prodotto  e':%g\n\n", V[i][0].prezzo);
 
 for(j=0;j<N[i]-1;j++)
    V[i][j]=V[i][j+1];
 
 N[i]--;
 V[i]=(struct prodotto *) realloc(V[i], sizeof(struct prodotto)*N[i]);
}


void in_lista(struct atomo **L, struct ordine x)
{
 struct atomo *aux;
 
 aux=(struct atomo *)malloc(sizeof(struct atomo));
 if(aux==NULL)
   {printf("\nL'inserimento e' impossibile\n\n");
    return;
    }
 
 aux->dato=x;
 aux->next=*L;
 *L=aux;
}


void elimina_ordine(struct atomo *L[5])
{int numero, tipo;
 struct atomo *aux, *l1,*l2;
 
 printf("Tipo di ordine che vuoi eliminare(0..4): ");
 scanf("%d", &tipo);
 if(L[tipo]==NULL)
   {printf("\nLa lista e' vuota e non e' possibile eliminare\n\n");
    return;
    }
 printf("Numero dell'ordine che vuoi eliminare: ");
 scanf("%d", &numero);
 
 if(L[tipo]->dato.numero==numero)
   { 
     printf("Codice dell'ordine :%d\n", L[tipo]->dato.codice);
     printf("Quantita' del prodotto ordinato :%d\n\n", L[tipo]->dato.quantita);
     aux=L[tipo];
     L[tipo]=aux->next;
     free(aux);
     return;
     }
  l1=L[tipo];
  l2=l1->next;
  
  while(l2!=NULL)
       if(numero==l2->dato.numero)
          { 
            printf("Codice dell'ordine :%d\n", l2->dato.codice);
            printf("Quantita' del prodottto ordinato :%d\n\n", l2->dato.quantita);
            l1->next=l2->next;
            free(l2);
            return;
            }
       else {l1=l2;
             l2=l2->next;
             }
  printf("\nNon esiste un ordine con tale numero e pertanto non e' possibile eliminarlo!\n\n");
}
  


void salva_tabella(struct prodotto *V[10], int N[10])
{
 FILE *pf;
 int i;
 
 pf=fopen("gestioneordine.ord", "w");
 if(pf) {
          for(i=0;i<10;i++)
             fwrite(V[i],sizeof(struct prodotto), N[i], pf);
             
          fclose(pf);
          }
 else printf("\nIl salvataggio non ha avuto successo\n\n");
}


void inizializza(struct prodotto *V[10], int N[10])
{
 FILE *pf;
 struct prodotto p;
 
 pf=fopen("gestioneordine.ord", "r");
 if(pf) {
         while(fread(&p,sizeof(struct prodotto),1,pf)!=0)
              in_tabella(V,N,p);
        
         fclose(pf);
         }

}



